/* $Id$

This file is part of NetVis
Copyright @ 2008 Mikko Rasa, Mikkosoft Productions
Distributed unter the GPL
*/

#ifndef HOST_H_
#define HOST_H_

#include <map>
#include <string>
#include <msp/time/timedelta.h>
#include "activity.h"
#include "vector2.h"

class NetVis;

class Host
{
private:
	NetVis &netvis;
	unsigned addr;
	std::string name;
	std::string short_name;
	bool local;
	Vector2 pos;
	bool active;
	Activity activity;
	float throttle;

public:
	Host(NetVis &, unsigned);
	unsigned get_address() const { return addr; }
	void set_name(const std::string &);
	const std::string &get_name() const { return name; }
	void set_local(bool);

	void set_position(const Vector2 &);
	const Vector2 &get_position() const { return pos; }

	void set_active(bool);
	bool get_active() const { return active; }
	void add_activity(unsigned);
	float get_activity() const { return activity.get_average(); }
	float send_packet();

	void tick(const Msp::Time::TimeDelta &);
	void render() const;
};

#endif
