/* $Id$

This file is part of NetVis
Copyright @ 2008 Mikko Rasa, Mikkosoft Productions
Distributed unter the GPL
*/

#ifndef PACKET_H_
#define PACKET_H_

#include <msp/gl/color.h>
#include <msp/time/timedelta.h>

class Host;

class Packet
{
private:
	const Host &src;
	const Host *dest;
	Msp::GL::Color color;
	float x;
	float size;
	float angle;
	float rspeed;

public:
	Packet(const Host &, const Host *, const Msp::GL::Color &, unsigned);
	bool get_stale() const { return x>=1; }
	void tick(const Msp::Time::TimeDelta &);
	void render(Msp::GL::PrimitiveBuilder &) const;
};

#endif
