/* $Id$

This file is part of NetVis
Copyright @ 2008 Mikko Rasa, Mikkosoft Productions
Distributed unter the GPL
*/

#ifndef PORT_H_
#define PORT_H_

#include <string>
#include <msp/gl/color.h>
#include <msp/gl/mesh.h>
#include "activity.h"

class NetVis;

class Port
{
private:
	NetVis &netvis;
	unsigned number;
	bool registered;
	std::string name;
	Msp::GL::Color color;
	Msp::GL::Mesh mesh;
	Activity activity;

public:
	Port(NetVis &, unsigned);

	unsigned get_number() const { return number; }
	bool is_registered() const { return registered; }
	const std::string &get_name() const { return name; }
	const Msp::GL::Color &get_color() const { return color; }

	void add_activity(unsigned);
	float get_activity() const { return activity.get_average(); }

	void tick(const Msp::Time::TimeDelta &);

	void render() const;
};

#endif
